<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Mini51 BSP: StdDriver/src/uart.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="M0Banner_v2.jpg"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Mini51 BSP
   &#160;<span id="projectnumber">V3.02.002</span>
   </div>
   <div id="projectbrief">The Board Support Package for Mini51 Series</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',false,false,'search.php','Search');
});
/* @license-end */</script>
<div id="main-nav"></div>
<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_0d398eaf8b2db165a9197a6619ec9f0e.html">StdDriver</a></li><li class="navelem"><a class="el" href="dir_3abedc03644d33bc69016fb8a5546004.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">uart.c</div>  </div>
</div><!--header-->
<div class="contents">
<a href="uart_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/**************************************************************************/</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="preprocessor">#include &lt;stdio.h&gt;</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_mini51_series_8h.html">Mini51Series.h</a>&quot;</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6caa32b208da0662b8f8bf2180fb57b7">   37</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6caa32b208da0662b8f8bf2180fb57b7">UART_ClearIntFlag</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint32_t u32InterruptFlag)</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;{</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordflow">if</span>(u32InterruptFlag &amp; <a class="code" href="_mini51_series_8h.html#ac3a4d33ba0d446f4e34d085889856343">UART_ISR_RLS_INT_Msk</a>)   <span class="comment">/* clear Receive Line Status Interrupt */</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a33f974990cecd0cd869698e411fb1387">FSR</a> |= <a class="code" href="_mini51_series_8h.html#a8c5bafdede6fa36fb80599f9bc0a6da9">UART_FSR_BIF_Msk</a> | <a class="code" href="_mini51_series_8h.html#a76b41a1683ac106067ddba0c4a18a42a">UART_FSR_FEF_Msk</a> | <a class="code" href="_mini51_series_8h.html#aa1e805b9852c7cc905e6deb907f0e715">UART_FSR_PEF_Msk</a>;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a33f974990cecd0cd869698e411fb1387">FSR</a> |= <a class="code" href="_mini51_series_8h.html#a514dcd5496412f6c75381c9c07a22603">UART_FSR_RS485_ADD_DETF_Msk</a>;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    }</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordflow">if</span>(u32InterruptFlag &amp; <a class="code" href="_mini51_series_8h.html#a03776650662dad0022ee7cf524e91f2e">UART_ISR_MODEM_INT_Msk</a>)  <span class="comment">/* clear Modem Interrupt */</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a8b4ced4b447af04fdadf9f9c904cb404">MSR</a> |= <a class="code" href="_mini51_series_8h.html#af2f76c555e7c0dab74fedd790076a4b2">UART_MSR_DCTSF_Msk</a>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keywordflow">if</span>(u32InterruptFlag &amp; <a class="code" href="_mini51_series_8h.html#a47abfe1d46dbdeada72be49842f98907">UART_ISR_BUF_ERR_INT_Msk</a>)   <span class="comment">/* clear Buffer Error Interrupt */</span></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    {</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a33f974990cecd0cd869698e411fb1387">FSR</a> |= <a class="code" href="_mini51_series_8h.html#ac027ed03079e8c9bead02d918932eb7d">UART_FSR_RX_OVER_IF_Msk</a> | <a class="code" href="_mini51_series_8h.html#a94b0eeb083f25f87ad3dd63694add91f">UART_FSR_TX_OVER_IF_Msk</a>;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    }</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordflow">if</span>(u32InterruptFlag &amp; <a class="code" href="_mini51_series_8h.html#a6b61df2f16733e9f04348780695e2390">UART_ISR_TOUT_INT_Msk</a>)  <span class="comment">/* clear Modem Interrupt */</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ac7af8ed45c1e8b85d8fb1ecd6bcb2105">ISR</a> |= <a class="code" href="_mini51_series_8h.html#abd772b269facd0ca2aabdd0210a702ea">UART_ISR_TOUT_IF_Msk</a>;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;}</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;</div><div class="line"><a name="l00067"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56ed1b6c204c2ee6054e2273126bca8e">   67</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56ed1b6c204c2ee6054e2273126bca8e">UART_Close</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart)</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;{</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">IER</a> = 0;</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;}</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;</div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6dcf73f1bd97886b6d501a9e932bcc60">   80</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6dcf73f1bd97886b6d501a9e932bcc60">UART_DisableFlowCtrl</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart)</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;{</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">IER</a> &amp;= ~(<a class="code" href="_mini51_series_8h.html#a46cdf8a60ae2505ed2d52d5c313f59ea">UART_IER_AUTO_RTS_EN_Msk</a> | <a class="code" href="_mini51_series_8h.html#ae0e0b0b2767452fb865e98d41711ef30">UART_IER_AUTO_CTS_EN_Msk</a>);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;}</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;</div><div class="line"><a name="l00102"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga978d8c95e3b536a84f56567f9eb35597">  102</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga978d8c95e3b536a84f56567f9eb35597">UART_DisableInt</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>*  uart, uint32_t u32InterruptFlag )</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;{</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">IER</a> &amp;= ~ u32InterruptFlag;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;}</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;</div><div class="line"><a name="l00116"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7b63c003589dc997066dc8e5b77d0662">  116</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7b63c003589dc997066dc8e5b77d0662">UART_EnableFlowCtrl</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart )</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;{</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ae6121886bb041a9f1c63911dcdbd8510">MCR</a> |= <a class="code" href="_mini51_series_8h.html#ae3f3018cccea00514e7d60219be03976">UART_MCR_LEV_RTS_Msk</a>;</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ae6121886bb041a9f1c63911dcdbd8510">MCR</a> &amp;= ~<a class="code" href="_mini51_series_8h.html#a4f7c62e5bfe1e701ee06e76239df71dc">UART_MCR_RTS_Msk</a>;</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a8b4ced4b447af04fdadf9f9c904cb404">MSR</a> |= <a class="code" href="_mini51_series_8h.html#a76b53e872426a281e8d1f02125b35f4c">UART_MSR_LEV_CTS_Msk</a>;</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">IER</a> |= <a class="code" href="_mini51_series_8h.html#a46cdf8a60ae2505ed2d52d5c313f59ea">UART_IER_AUTO_RTS_EN_Msk</a> | <a class="code" href="_mini51_series_8h.html#ae0e0b0b2767452fb865e98d41711ef30">UART_IER_AUTO_CTS_EN_Msk</a>;</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;}</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;</div><div class="line"><a name="l00141"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga13b38c30bd15f9e1f2bd4fb1cbe418cc">  141</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga13b38c30bd15f9e1f2bd4fb1cbe418cc">UART_EnableInt</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>*  uart, uint32_t u32InterruptFlag )</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;{</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">IER</a> |= u32InterruptFlag;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;}</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;</div><div class="line"><a name="l00155"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gadcca8d11ae146138c089c65c2a9eb428">  155</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gadcca8d11ae146138c089c65c2a9eb428">UART_Open</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint32_t u32baudrate)</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;{</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    uint8_t u8UartClkSrcSel;</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    uint32_t u32ClkDiv = 0;</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    uint32_t u32Clk = 0;</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    uint32_t u32ClkTbl[4] = {<a class="code" href="system___mini51_series_8h.html#a8687edecd98881631a879bd10528c7da">__XTAL</a>, 0, <a class="code" href="system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a>, <a class="code" href="system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a>};</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    uint32_t u32Baud_Div;</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    u8UartClkSrcSel = (<a class="code" href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 &amp; <a class="code" href="_mini51_series_8h.html#ac8e05bf8810b71cf6083bfd25a190fe3">CLK_CLKSEL1_UART_S_Msk</a>) &gt;&gt; <a class="code" href="_mini51_series_8h.html#ac2ed640c8370f88d9311586d568d8511">CLK_CLKSEL1_UART_S_Pos</a>;</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;    u32ClkDiv = ( (<a class="code" href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV &amp; <a class="code" href="_mini51_series_8h.html#a452219d3ebdd57f220ba7cc6238817ee">CLK_CLKDIV_UART_N_Msk</a>) &gt;&gt; <a class="code" href="_mini51_series_8h.html#abd5f50dc4b8a1f00f4d01c59ecda4c95">CLK_CLKDIV_UART_N_Pos</a> );</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a7601c8d1529c8f59347b7a0089709f08">FUN_SEL</a> = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gac756ade4c2a338617e80a2fed0ef0049">UART_FUNC_SEL_UART</a>;</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a024625ad6f6776b46d26d7b18adb7b99">LCR</a> = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga861ae53255163bf7cd2d80d913cebb1d">UART_WORD_LEN_8</a> | <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga270dea6e1a92dd83fe58802450bdd60c">UART_PARITY_NONE</a> | <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga58e87dcac022388ad406eb83031777db">UART_STOP_BIT_1</a>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a1b85a7395e434cbf4bee23062a032585">FCR</a> = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gafc2b593120692151bdafe37030fe6c41">UART_FCR_RFITL_1BYTE</a> | <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga9cbecab2f6dd0ac2f5047d433479eefe">UART_FCR_RTS_TRI_LEV_1BYTE</a>;</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;    u32Clk = u32ClkTbl[u8UartClkSrcSel]/(u32ClkDiv + 1);</div><div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;    <span class="keywordflow">if</span>(u32baudrate != 0)</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;    {</div><div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        u32Baud_Div = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7e5bef7359154929202790132aa821ec">UART_BAUD_MODE2_DIVIDER</a>(u32Clk, u32baudrate);</div><div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordflow">if</span>(u32Baud_Div &gt; 0xFFFF)</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;            uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">BAUD</a> = (<a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga2b95702ec6143af8ae540638f6ff80f2">UART_BAUD_MODE0</a> | <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga59118911e1bb8d8dfd8efa40bddcd1a5">UART_BAUD_MODE0_DIVIDER</a>(u32Clk, u32baudrate));</div><div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;            uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">BAUD</a> = (<a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga24e250ad638c968b36c1e892bbdc5cd2">UART_BAUD_MODE2</a> | u32Baud_Div);</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    }</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;}</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;</div><div class="line"><a name="l00195"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gace2c59bec6efa5ccd85986f5fa15c7e0">  195</a></span>&#160;uint32_t <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gace2c59bec6efa5ccd85986f5fa15c7e0">UART_Read</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint8_t *pu8RxBuf, uint32_t u32ReadBytes)</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;{</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    uint32_t  u32Count, u32delayno;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    <span class="keywordflow">for</span>(u32Count=0; u32Count &lt; u32ReadBytes; u32Count++)</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    {</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        u32delayno = 0;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        <span class="keywordflow">while</span>(uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a33f974990cecd0cd869698e411fb1387">FSR</a> &amp; <a class="code" href="_mini51_series_8h.html#aad5a5b1a99f9f4b5f7ecca6313a582e8">UART_FSR_RX_EMPTY_Msk</a>)   <span class="comment">/* Check RX empty =&gt; failed */</span></div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        {</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;            u32delayno++;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;            <span class="keywordflow">if</span>( u32delayno &gt;= 0x40000000 )</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;                <span class="keywordflow">return</span> <a class="code" href="group___m_i_n_i51__legacy___constants.html#gaa93f0eb578d23995850d61f7d61c55c1">FALSE</a>;</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        }</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        pu8RxBuf[u32Count] = uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a413676eb36f2215c4a51372f33a68ee3">RBR</a>;    <span class="comment">/* Get Data from UART RX  */</span></div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    }</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <span class="keywordflow">return</span> u32Count;</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;}</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;</div><div class="line"><a name="l00229"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga83fe107ad6c49af362366874e4a730e9">  229</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga83fe107ad6c49af362366874e4a730e9">UART_SetLine_Config</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint32_t u32baudrate, uint32_t u32data_width, uint32_t u32parity, uint32_t  u32stop_bits)</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;{</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    uint8_t u8UartClkSrcSel;</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    uint32_t u32ClkDiv = 0;</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    uint32_t u32Clk = 0;</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    uint32_t u32ClkTbl[4] = {<a class="code" href="system___mini51_series_8h.html#a8687edecd98881631a879bd10528c7da">__XTAL</a>, 0, <a class="code" href="system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a>, <a class="code" href="system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a>};</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    uint32_t u32Baud_Div = 0;</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    u8UartClkSrcSel = (<a class="code" href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 &amp; <a class="code" href="_mini51_series_8h.html#ac8e05bf8810b71cf6083bfd25a190fe3">CLK_CLKSEL1_UART_S_Msk</a>) &gt;&gt; <a class="code" href="_mini51_series_8h.html#ac2ed640c8370f88d9311586d568d8511">CLK_CLKSEL1_UART_S_Pos</a>;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    u32ClkDiv = ( (<a class="code" href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV &amp; <a class="code" href="_mini51_series_8h.html#a452219d3ebdd57f220ba7cc6238817ee">CLK_CLKDIV_UART_N_Msk</a>) &gt;&gt; <a class="code" href="_mini51_series_8h.html#abd5f50dc4b8a1f00f4d01c59ecda4c95">CLK_CLKDIV_UART_N_Pos</a> );</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    u32Clk = u32ClkTbl[u8UartClkSrcSel]/(u32ClkDiv + 1);</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <span class="keywordflow">if</span>(u32baudrate != 0)</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    {</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        u32Baud_Div = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7e5bef7359154929202790132aa821ec">UART_BAUD_MODE2_DIVIDER</a>(u32Clk, u32baudrate);</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keywordflow">if</span>(u32Baud_Div &gt; 0xFFFF)</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;            uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">BAUD</a> = (<a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga2b95702ec6143af8ae540638f6ff80f2">UART_BAUD_MODE0</a> | <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga59118911e1bb8d8dfd8efa40bddcd1a5">UART_BAUD_MODE0_DIVIDER</a>(u32Clk, u32baudrate));</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">BAUD</a> = (<a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga24e250ad638c968b36c1e892bbdc5cd2">UART_BAUD_MODE2</a> | u32Baud_Div);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    }</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a024625ad6f6776b46d26d7b18adb7b99">LCR</a> = u32data_width | u32parity | u32stop_bits;</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;}</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;</div><div class="line"><a name="l00264"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga4c9d81ea9193f20ebfbd7873a4cdc8cb">  264</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga4c9d81ea9193f20ebfbd7873a4cdc8cb">UART_SetTimeoutCnt</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint32_t u32TOC)</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;{</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a27a280db5df6e6fa46d77fe99a4d143b">TOR</a> = (uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a27a280db5df6e6fa46d77fe99a4d143b">TOR</a> &amp; ~<a class="code" href="_mini51_series_8h.html#a5340ca18f910c2836c1f99c8a49a3395">UART_TOR_TOIC_Msk</a>)| (u32TOC);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">IER</a> |= <a class="code" href="_mini51_series_8h.html#a42c021cb0fbf8cd66e431fa6f0ef0df7">UART_IER_TIME_OUT_EN_Msk</a>;</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;}</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;</div><div class="line"><a name="l00280"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gab74d997a2c280fedd422b65cc06ed4e1">  280</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gab74d997a2c280fedd422b65cc06ed4e1">UART_SelectIrDAMode</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint32_t u32Buadrate, uint32_t u32Direction)</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;{</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    uint8_t u8UartClkSrcSel = 0;</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    uint32_t u32ClkDiv = 0;</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    uint32_t u32Clk = 0;</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    uint32_t u32Baud_Div = 0;</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    u8UartClkSrcSel = (<a class="code" href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKSEL1 &amp; <a class="code" href="_mini51_series_8h.html#ac8e05bf8810b71cf6083bfd25a190fe3">CLK_CLKSEL1_UART_S_Msk</a>) &gt;&gt; <a class="code" href="_mini51_series_8h.html#ac2ed640c8370f88d9311586d568d8511">CLK_CLKSEL1_UART_S_Pos</a>;</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    u32ClkDiv = ( (<a class="code" href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a>-&gt;CLKDIV &amp; <a class="code" href="_mini51_series_8h.html#a452219d3ebdd57f220ba7cc6238817ee">CLK_CLKDIV_UART_N_Msk</a>) &gt;&gt; <a class="code" href="_mini51_series_8h.html#abd5f50dc4b8a1f00f4d01c59ecda4c95">CLK_CLKDIV_UART_N_Pos</a> );</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <span class="keywordflow">if</span>(u8UartClkSrcSel == 0)</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;        u32Clk = <a class="code" href="system___mini51_series_8h.html#a8687edecd98881631a879bd10528c7da">__XTAL</a>;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span>(u8UartClkSrcSel &gt;= 2)</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;        u32Clk = <a class="code" href="system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a>;</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    u32Clk = u32Clk/(u32ClkDiv + 1);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <span class="keywordflow">if</span>(u32Buadrate != 0)</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    {</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        u32Baud_Div = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7e5bef7359154929202790132aa821ec">UART_BAUD_MODE2_DIVIDER</a>(u32Clk, u32Buadrate);</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        <span class="keywordflow">if</span>(u32Baud_Div &gt; 0xFFFF)</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;            uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">BAUD</a> = (<a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga2b95702ec6143af8ae540638f6ff80f2">UART_BAUD_MODE0</a> | <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga59118911e1bb8d8dfd8efa40bddcd1a5">UART_BAUD_MODE0_DIVIDER</a>(u32Clk, u32Buadrate));</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        <span class="keywordflow">else</span></div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;            uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">BAUD</a> = (<a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga24e250ad638c968b36c1e892bbdc5cd2">UART_BAUD_MODE2</a> | u32Baud_Div);</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    }</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ab5cada1c17dd9fd3825ce247a6f88180">IRCR</a>    &amp;=  ~<a class="code" href="_mini51_series_8h.html#a90df50b933907e88025151cf09eac3c2">UART_IRCR_INV_TX_Msk</a>;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ab5cada1c17dd9fd3825ce247a6f88180">IRCR</a> |=     <a class="code" href="_mini51_series_8h.html#a2d0ff89f5851427e9dcf641d9f2537d4">UART_IRCR_INV_RX_Msk</a>;</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ab5cada1c17dd9fd3825ce247a6f88180">IRCR</a>    = u32Direction ? uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ab5cada1c17dd9fd3825ce247a6f88180">IRCR</a> | <a class="code" href="_mini51_series_8h.html#a10df7c4c9ac2f83a1241471f7da18add">UART_IRCR_TX_SELECT_Msk</a> : uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#ab5cada1c17dd9fd3825ce247a6f88180">IRCR</a> &amp;~<a class="code" href="_mini51_series_8h.html#a10df7c4c9ac2f83a1241471f7da18add"> UART_IRCR_TX_SELECT_Msk</a>;</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a7601c8d1529c8f59347b7a0089709f08">FUN_SEL</a> = (0x2 &lt;&lt; <a class="code" href="_mini51_series_8h.html#a7da65ccd8e9d5ea59979b62a5b830a7b">UART_FUN_SEL_FUN_SEL_Pos</a>);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;}</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div><div class="line"><a name="l00324"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga012cceda57fbf706282dfc225754f9ab">  324</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga012cceda57fbf706282dfc225754f9ab">UART_SelectRS485Mode</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart, uint32_t u32Mode, uint32_t u32Addr)</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;{</div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a7601c8d1529c8f59347b7a0089709f08">FUN_SEL</a> = <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gae4d52ef14ffe0c22f147f339f0a46e1e">UART_FUNC_SEL_RS485</a>;</div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#abda0c1126e0c2c119c3768a67cc1ed35">ALT_CSR</a> = 0;</div><div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;    uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#abda0c1126e0c2c119c3768a67cc1ed35">ALT_CSR</a> |= u32Mode | (u32Addr &lt;&lt; <a class="code" href="_mini51_series_8h.html#a361cb75ff808f0a01163f59ad1e56f6b">UART_ALT_CSR_ADDR_MATCH_Pos</a>);</div><div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;}</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;</div><div class="line"><a name="l00341"></a><span class="lineno"><a class="line" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7c407ea077120e5e2e19b44742554137">  341</a></span>&#160;uint32_t <a class="code" href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7c407ea077120e5e2e19b44742554137">UART_Write</a>(<a class="code" href="struct_u_a_r_t___t.html">UART_T</a>* uart,uint8_t *pu8TxBuf, uint32_t u32WriteBytes)</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;{</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    uint32_t  u32Count, u32delayno;</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;    <span class="keywordflow">for</span>(u32Count=0; u32Count != u32WriteBytes; u32Count++)</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    {</div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;        u32delayno = 0;</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;        <span class="keywordflow">while</span>((uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a33f974990cecd0cd869698e411fb1387">FSR</a> &amp; <a class="code" href="_mini51_series_8h.html#ad4fca453c297f1087919720dc06dddbc">UART_FSR_TE_FLAG_Msk</a>) == 0)   <span class="comment">/* Wait Tx empty and Time-out manner */</span></div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;        {</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;            u32delayno++;</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;            <span class="keywordflow">if</span>( u32delayno &gt;= 0x40000000 )</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;                <span class="keywordflow">return</span> <a class="code" href="group___m_i_n_i51__legacy___constants.html#gaa93f0eb578d23995850d61f7d61c55c1">FALSE</a>;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        }</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        uart-&gt;<a class="code" href="struct_u_a_r_t___t.html#a1ff3c208c8ca5807684ff84d35bb3e03">THR</a> = pu8TxBuf[u32Count];    <span class="comment">/* Send UART Data from buffer */</span></div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    }</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;    <span class="keywordflow">return</span> u32Count;</div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;}</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160; <span class="comment">/* end of group MINI51_UART_EXPORTED_FUNCTIONS */</span></div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160; <span class="comment">/* end of group MINI51_UART_Driver */</span></div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160; <span class="comment">/* end of group MINI51_Device_Driver */</span></div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;<span class="comment">/*** (C) COPYRIGHT 2012 Nuvoton Technology Corp. ***/</span></div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;</div><div class="ttc" id="_mini51_series_8h_html_a4f7c62e5bfe1e701ee06e76239df71dc"><div class="ttname"><a href="_mini51_series_8h.html#a4f7c62e5bfe1e701ee06e76239df71dc">UART_MCR_RTS_Msk</a></div><div class="ttdeci">#define UART_MCR_RTS_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09548">Mini51Series.h:9548</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a1b85a7395e434cbf4bee23062a032585"><div class="ttname"><a href="struct_u_a_r_t___t.html#a1b85a7395e434cbf4bee23062a032585">UART_T::FCR</a></div><div class="ttdeci">__IO uint32_t FCR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09457">Mini51Series.h:9457</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga4c9d81ea9193f20ebfbd7873a4cdc8cb"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga4c9d81ea9193f20ebfbd7873a4cdc8cb">UART_SetTimeoutCnt</a></div><div class="ttdeci">void UART_SetTimeoutCnt(UART_T *uart, uint32_t u32TOC)</div><div class="ttdoc">This function use to set Rx timeout count.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00264">uart.c:264</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_ad1b5663f0b3de889caac30060643a383"><div class="ttname"><a href="struct_u_a_r_t___t.html#ad1b5663f0b3de889caac30060643a383">UART_T::IER</a></div><div class="ttdeci">__IO uint32_t IER</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09456">Mini51Series.h:9456</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a6b61df2f16733e9f04348780695e2390"><div class="ttname"><a href="_mini51_series_8h.html#a6b61df2f16733e9f04348780695e2390">UART_ISR_TOUT_INT_Msk</a></div><div class="ttdeci">#define UART_ISR_TOUT_INT_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09635">Mini51Series.h:9635</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_abd772b269facd0ca2aabdd0210a702ea"><div class="ttname"><a href="_mini51_series_8h.html#abd772b269facd0ca2aabdd0210a702ea">UART_ISR_TOUT_IF_Msk</a></div><div class="ttdeci">#define UART_ISR_TOUT_IF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09617">Mini51Series.h:9617</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a8c5bafdede6fa36fb80599f9bc0a6da9"><div class="ttname"><a href="_mini51_series_8h.html#a8c5bafdede6fa36fb80599f9bc0a6da9">UART_FSR_BIF_Msk</a></div><div class="ttdeci">#define UART_FSR_BIF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09578">Mini51Series.h:9578</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a76b53e872426a281e8d1f02125b35f4c"><div class="ttname"><a href="_mini51_series_8h.html#a76b53e872426a281e8d1f02125b35f4c">UART_MSR_LEV_CTS_Msk</a></div><div class="ttdeci">#define UART_MSR_LEV_CTS_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09563">Mini51Series.h:9563</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a7601c8d1529c8f59347b7a0089709f08"><div class="ttname"><a href="struct_u_a_r_t___t.html#a7601c8d1529c8f59347b7a0089709f08">UART_T::FUN_SEL</a></div><div class="ttdeci">__IO uint32_t FUN_SEL</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09467">Mini51Series.h:9467</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_af2f76c555e7c0dab74fedd790076a4b2"><div class="ttname"><a href="_mini51_series_8h.html#af2f76c555e7c0dab74fedd790076a4b2">UART_MSR_DCTSF_Msk</a></div><div class="ttdeci">#define UART_MSR_DCTSF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09557">Mini51Series.h:9557</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga58e87dcac022388ad406eb83031777db"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga58e87dcac022388ad406eb83031777db">UART_STOP_BIT_1</a></div><div class="ttdeci">#define UART_STOP_BIT_1</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00061">uart.h:61</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a46cdf8a60ae2505ed2d52d5c313f59ea"><div class="ttname"><a href="_mini51_series_8h.html#a46cdf8a60ae2505ed2d52d5c313f59ea">UART_IER_AUTO_RTS_EN_Msk</a></div><div class="ttdeci">#define UART_IER_AUTO_RTS_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09509">Mini51Series.h:9509</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ae3f3018cccea00514e7d60219be03976"><div class="ttname"><a href="_mini51_series_8h.html#ae3f3018cccea00514e7d60219be03976">UART_MCR_LEV_RTS_Msk</a></div><div class="ttdeci">#define UART_MCR_LEV_RTS_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09551">Mini51Series.h:9551</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a7da65ccd8e9d5ea59979b62a5b830a7b"><div class="ttname"><a href="_mini51_series_8h.html#a7da65ccd8e9d5ea59979b62a5b830a7b">UART_FUN_SEL_FUN_SEL_Pos</a></div><div class="ttdeci">#define UART_FUN_SEL_FUN_SEL_Pos</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09682">Mini51Series.h:9682</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gab74d997a2c280fedd422b65cc06ed4e1"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gab74d997a2c280fedd422b65cc06ed4e1">UART_SelectIrDAMode</a></div><div class="ttdeci">void UART_SelectIrDAMode(UART_T *uart, uint32_t u32Buadrate, uint32_t u32Direction)</div><div class="ttdoc">The function is used to configure IrDA relative settings. It consists of TX or RX mode and baudrate.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00280">uart.c:280</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga56ed1b6c204c2ee6054e2273126bca8e"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga56ed1b6c204c2ee6054e2273126bca8e">UART_Close</a></div><div class="ttdeci">void UART_Close(UART_T *uart)</div><div class="ttdoc">The function is used to disable UART.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00067">uart.c:67</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ac027ed03079e8c9bead02d918932eb7d"><div class="ttname"><a href="_mini51_series_8h.html#ac027ed03079e8c9bead02d918932eb7d">UART_FSR_RX_OVER_IF_Msk</a></div><div class="ttdeci">#define UART_FSR_RX_OVER_IF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09566">Mini51Series.h:9566</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gadcca8d11ae146138c089c65c2a9eb428"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gadcca8d11ae146138c089c65c2a9eb428">UART_Open</a></div><div class="ttdeci">void UART_Open(UART_T *uart, uint32_t u32baudrate)</div><div class="ttdoc">This function use to enable UART function and set baud-rate.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00155">uart.c:155</a></div></div>
<div class="ttc" id="_mini51_series_8h_html"><div class="ttname"><a href="_mini51_series_8h.html">Mini51Series.h</a></div><div class="ttdoc">Mini51 series peripheral access layer header file. This file contains all the peripheral register's d...</div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_ac7af8ed45c1e8b85d8fb1ecd6bcb2105"><div class="ttname"><a href="struct_u_a_r_t___t.html#ac7af8ed45c1e8b85d8fb1ecd6bcb2105">UART_T::ISR</a></div><div class="ttdeci">__IO uint32_t ISR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09462">Mini51Series.h:9462</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga270dea6e1a92dd83fe58802450bdd60c"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga270dea6e1a92dd83fe58802450bdd60c">UART_PARITY_NONE</a></div><div class="ttdeci">#define UART_PARITY_NONE</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00055">uart.h:55</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gac756ade4c2a338617e80a2fed0ef0049"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gac756ade4c2a338617e80a2fed0ef0049">UART_FUNC_SEL_UART</a></div><div class="ttdeci">#define UART_FUNC_SEL_UART</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00075">uart.h:75</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a94b0eeb083f25f87ad3dd63694add91f"><div class="ttname"><a href="_mini51_series_8h.html#a94b0eeb083f25f87ad3dd63694add91f">UART_FSR_TX_OVER_IF_Msk</a></div><div class="ttdeci">#define UART_FSR_TX_OVER_IF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09599">Mini51Series.h:9599</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga6caa32b208da0662b8f8bf2180fb57b7"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6caa32b208da0662b8f8bf2180fb57b7">UART_ClearIntFlag</a></div><div class="ttdeci">void UART_ClearIntFlag(UART_T *uart, uint32_t u32InterruptFlag)</div><div class="ttdoc">The function is used to clear UART specified interrupt flag.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00037">uart.c:37</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a024625ad6f6776b46d26d7b18adb7b99"><div class="ttname"><a href="struct_u_a_r_t___t.html#a024625ad6f6776b46d26d7b18adb7b99">UART_T::LCR</a></div><div class="ttdeci">__IO uint32_t LCR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09458">Mini51Series.h:9458</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga83fe107ad6c49af362366874e4a730e9"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga83fe107ad6c49af362366874e4a730e9">UART_SetLine_Config</a></div><div class="ttdeci">void UART_SetLine_Config(UART_T *uart, uint32_t u32baudrate, uint32_t u32data_width, uint32_t u32parity, uint32_t u32stop_bits)</div><div class="ttdoc">This function use to config UART line setting.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00229">uart.c:229</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a76b41a1683ac106067ddba0c4a18a42a"><div class="ttname"><a href="_mini51_series_8h.html#a76b41a1683ac106067ddba0c4a18a42a">UART_FSR_FEF_Msk</a></div><div class="ttdeci">#define UART_FSR_FEF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09575">Mini51Series.h:9575</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga7c407ea077120e5e2e19b44742554137"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7c407ea077120e5e2e19b44742554137">UART_Write</a></div><div class="ttdeci">uint32_t UART_Write(UART_T *uart, uint8_t *pu8TxBuf, uint32_t u32WriteBytes)</div><div class="ttdoc">The function is to write data into TX buffer to transmit data by UART.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00341">uart.c:341</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ac3a4d33ba0d446f4e34d085889856343"><div class="ttname"><a href="_mini51_series_8h.html#ac3a4d33ba0d446f4e34d085889856343">UART_ISR_RLS_INT_Msk</a></div><div class="ttdeci">#define UART_ISR_RLS_INT_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09629">Mini51Series.h:9629</a></div></div>
<div class="ttc" id="system___mini51_series_8h_html_a8687edecd98881631a879bd10528c7da"><div class="ttname"><a href="system___mini51_series_8h.html#a8687edecd98881631a879bd10528c7da">__XTAL</a></div><div class="ttdeci">#define __XTAL</div><div class="ttdef"><b>Definition:</b> <a href="system___mini51_series_8h_source.html#l00033">system_Mini51Series.h:33</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ac8e05bf8810b71cf6083bfd25a190fe3"><div class="ttname"><a href="_mini51_series_8h.html#ac8e05bf8810b71cf6083bfd25a190fe3">CLK_CLKSEL1_UART_S_Msk</a></div><div class="ttdeci">#define CLK_CLKSEL1_UART_S_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l01601">Mini51Series.h:1601</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a2d0ff89f5851427e9dcf641d9f2537d4"><div class="ttname"><a href="_mini51_series_8h.html#a2d0ff89f5851427e9dcf641d9f2537d4">UART_IRCR_INV_RX_Msk</a></div><div class="ttdeci">#define UART_IRCR_INV_RX_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09665">Mini51Series.h:9665</a></div></div>
<div class="ttc" id="group___m_i_n_i51__legacy___constants_html_gaa93f0eb578d23995850d61f7d61c55c1"><div class="ttname"><a href="group___m_i_n_i51__legacy___constants.html#gaa93f0eb578d23995850d61f7d61c55c1">FALSE</a></div><div class="ttdeci">#define FALSE</div><div class="ttdoc">Boolean false, define to use in API parameters or return value.</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l10097">Mini51Series.h:10097</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga13b38c30bd15f9e1f2bd4fb1cbe418cc"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga13b38c30bd15f9e1f2bd4fb1cbe418cc">UART_EnableInt</a></div><div class="ttdeci">void UART_EnableInt(UART_T *uart, uint32_t u32InterruptFlag)</div><div class="ttdoc">The function is used to enable UART specified interrupt and disable NVIC UART IRQ.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00141">uart.c:141</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_abda0c1126e0c2c119c3768a67cc1ed35"><div class="ttname"><a href="struct_u_a_r_t___t.html#abda0c1126e0c2c119c3768a67cc1ed35">UART_T::ALT_CSR</a></div><div class="ttdeci">__IO uint32_t ALT_CSR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09466">Mini51Series.h:9466</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga9cbecab2f6dd0ac2f5047d433479eefe"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga9cbecab2f6dd0ac2f5047d433479eefe">UART_FCR_RTS_TRI_LEV_1BYTE</a></div><div class="ttdeci">#define UART_FCR_RTS_TRI_LEV_1BYTE</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00042">uart.h:42</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a60210f63317de5a3432d775dbc4c9209"><div class="ttname"><a href="struct_u_a_r_t___t.html#a60210f63317de5a3432d775dbc4c9209">UART_T::BAUD</a></div><div class="ttdeci">__IO uint32_t BAUD</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09464">Mini51Series.h:9464</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_ae6121886bb041a9f1c63911dcdbd8510"><div class="ttname"><a href="struct_u_a_r_t___t.html#ae6121886bb041a9f1c63911dcdbd8510">UART_T::MCR</a></div><div class="ttdeci">__IO uint32_t MCR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09459">Mini51Series.h:9459</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga2b95702ec6143af8ae540638f6ff80f2"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga2b95702ec6143af8ae540638f6ff80f2">UART_BAUD_MODE0</a></div><div class="ttdeci">#define UART_BAUD_MODE0</div><div class="ttdoc">Calculate UART baudrate mode0 divider.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00095">uart.h:95</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ac2ed640c8370f88d9311586d568d8511"><div class="ttname"><a href="_mini51_series_8h.html#ac2ed640c8370f88d9311586d568d8511">CLK_CLKSEL1_UART_S_Pos</a></div><div class="ttdeci">#define CLK_CLKSEL1_UART_S_Pos</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l01600">Mini51Series.h:1600</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga7b63c003589dc997066dc8e5b77d0662"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7b63c003589dc997066dc8e5b77d0662">UART_EnableFlowCtrl</a></div><div class="ttdeci">void UART_EnableFlowCtrl(UART_T *uart)</div><div class="ttdoc">The function is used to Enable UART auto flow control.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00116">uart.c:116</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_abd5f50dc4b8a1f00f4d01c59ecda4c95"><div class="ttname"><a href="_mini51_series_8h.html#abd5f50dc4b8a1f00f4d01c59ecda4c95">CLK_CLKDIV_UART_N_Pos</a></div><div class="ttdeci">#define CLK_CLKDIV_UART_N_Pos</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l01606">Mini51Series.h:1606</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a5340ca18f910c2836c1f99c8a49a3395"><div class="ttname"><a href="_mini51_series_8h.html#a5340ca18f910c2836c1f99c8a49a3395">UART_TOR_TOIC_Msk</a></div><div class="ttdeci">#define UART_TOR_TOIC_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09641">Mini51Series.h:9641</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a8b4ced4b447af04fdadf9f9c904cb404"><div class="ttname"><a href="struct_u_a_r_t___t.html#a8b4ced4b447af04fdadf9f9c904cb404">UART_T::MSR</a></div><div class="ttdeci">__IO uint32_t MSR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09460">Mini51Series.h:9460</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a33f974990cecd0cd869698e411fb1387"><div class="ttname"><a href="struct_u_a_r_t___t.html#a33f974990cecd0cd869698e411fb1387">UART_T::FSR</a></div><div class="ttdeci">__IO uint32_t FSR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09461">Mini51Series.h:9461</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a1ff3c208c8ca5807684ff84d35bb3e03"><div class="ttname"><a href="struct_u_a_r_t___t.html#a1ff3c208c8ca5807684ff84d35bb3e03">UART_T::THR</a></div><div class="ttdeci">__O uint32_t THR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09454">Mini51Series.h:9454</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga7e5bef7359154929202790132aa821ec"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga7e5bef7359154929202790132aa821ec">UART_BAUD_MODE2_DIVIDER</a></div><div class="ttdeci">#define UART_BAUD_MODE2_DIVIDER(u32SrcFreq, u32BaudRate)</div><div class="ttdoc">Calculate UART baudrate mode2 divider.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00127">uart.h:127</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga6dcf73f1bd97886b6d501a9e932bcc60"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga6dcf73f1bd97886b6d501a9e932bcc60">UART_DisableFlowCtrl</a></div><div class="ttdeci">void UART_DisableFlowCtrl(UART_T *uart)</div><div class="ttdoc">The function is used to disable UART auto flow control.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00080">uart.c:80</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_aad5a5b1a99f9f4b5f7ecca6313a582e8"><div class="ttname"><a href="_mini51_series_8h.html#aad5a5b1a99f9f4b5f7ecca6313a582e8">UART_FSR_RX_EMPTY_Msk</a></div><div class="ttdeci">#define UART_FSR_RX_EMPTY_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09584">Mini51Series.h:9584</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gafc2b593120692151bdafe37030fe6c41"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gafc2b593120692151bdafe37030fe6c41">UART_FCR_RFITL_1BYTE</a></div><div class="ttdeci">#define UART_FCR_RFITL_1BYTE</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00037">uart.h:37</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_ga861ae53255163bf7cd2d80d913cebb1d"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#ga861ae53255163bf7cd2d80d913cebb1d">UART_WORD_LEN_8</a></div><div class="ttdeci">#define UART_WORD_LEN_8</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00053">uart.h:53</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_ab5cada1c17dd9fd3825ce247a6f88180"><div class="ttname"><a href="struct_u_a_r_t___t.html#ab5cada1c17dd9fd3825ce247a6f88180">UART_T::IRCR</a></div><div class="ttdeci">__IO uint32_t IRCR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09465">Mini51Series.h:9465</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a452219d3ebdd57f220ba7cc6238817ee"><div class="ttname"><a href="_mini51_series_8h.html#a452219d3ebdd57f220ba7cc6238817ee">CLK_CLKDIV_UART_N_Msk</a></div><div class="ttdeci">#define CLK_CLKDIV_UART_N_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l01607">Mini51Series.h:1607</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a90df50b933907e88025151cf09eac3c2"><div class="ttname"><a href="_mini51_series_8h.html#a90df50b933907e88025151cf09eac3c2">UART_IRCR_INV_TX_Msk</a></div><div class="ttdeci">#define UART_IRCR_INV_TX_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09662">Mini51Series.h:9662</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ad4fca453c297f1087919720dc06dddbc"><div class="ttname"><a href="_mini51_series_8h.html#ad4fca453c297f1087919720dc06dddbc">UART_FSR_TE_FLAG_Msk</a></div><div class="ttdeci">#define UART_FSR_TE_FLAG_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09602">Mini51Series.h:9602</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga24e250ad638c968b36c1e892bbdc5cd2"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga24e250ad638c968b36c1e892bbdc5cd2">UART_BAUD_MODE2</a></div><div class="ttdeci">#define UART_BAUD_MODE2</div><div class="ttdoc">Calculate UART baudrate mode0 divider.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00105">uart.h:105</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga59118911e1bb8d8dfd8efa40bddcd1a5"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga59118911e1bb8d8dfd8efa40bddcd1a5">UART_BAUD_MODE0_DIVIDER</a></div><div class="ttdeci">#define UART_BAUD_MODE0_DIVIDER(u32SrcFreq, u32BaudRate)</div><div class="ttdoc">Calculate UART baudrate mode0 divider.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00117">uart.h:117</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s_html_gae4d52ef14ffe0c22f147f339f0a46e1e"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___c_o_n_s_t_a_n_t_s.html#gae4d52ef14ffe0c22f147f339f0a46e1e">UART_FUNC_SEL_RS485</a></div><div class="ttdeci">#define UART_FUNC_SEL_RS485</div><div class="ttdef"><b>Definition:</b> <a href="uart_8h_source.html#l00077">uart.h:77</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a413676eb36f2215c4a51372f33a68ee3"><div class="ttname"><a href="struct_u_a_r_t___t.html#a413676eb36f2215c4a51372f33a68ee3">UART_T::RBR</a></div><div class="ttdeci">__I uint32_t RBR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09453">Mini51Series.h:9453</a></div></div>
<div class="ttc" id="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n_html_ga4b355291fe6b8ba8e167ab0faa862e45"><div class="ttname"><a href="group___m_i_n_i51___p_e_r_i_p_h_e_r_a_l___d_e_c_l_a_r_a_t_i_o_n.html#ga4b355291fe6b8ba8e167ab0faa862e45">CLK</a></div><div class="ttdeci">#define CLK</div><div class="ttdoc">Pointer to CLK register structure.</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09937">Mini51Series.h:9937</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga012cceda57fbf706282dfc225754f9ab"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga012cceda57fbf706282dfc225754f9ab">UART_SelectRS485Mode</a></div><div class="ttdeci">void UART_SelectRS485Mode(UART_T *uart, uint32_t u32Mode, uint32_t u32Addr)</div><div class="ttdoc">The function is used to set RS485 relative setting.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00324">uart.c:324</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a42c021cb0fbf8cd66e431fa6f0ef0df7"><div class="ttname"><a href="_mini51_series_8h.html#a42c021cb0fbf8cd66e431fa6f0ef0df7">UART_IER_TIME_OUT_EN_Msk</a></div><div class="ttdeci">#define UART_IER_TIME_OUT_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09506">Mini51Series.h:9506</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a361cb75ff808f0a01163f59ad1e56f6b"><div class="ttname"><a href="_mini51_series_8h.html#a361cb75ff808f0a01163f59ad1e56f6b">UART_ALT_CSR_ADDR_MATCH_Pos</a></div><div class="ttdeci">#define UART_ALT_CSR_ADDR_MATCH_Pos</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09679">Mini51Series.h:9679</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html"><div class="ttname"><a href="struct_u_a_r_t___t.html">UART_T</a></div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l08567">Mini51Series.h:8567</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_ae0e0b0b2767452fb865e98d41711ef30"><div class="ttname"><a href="_mini51_series_8h.html#ae0e0b0b2767452fb865e98d41711ef30">UART_IER_AUTO_CTS_EN_Msk</a></div><div class="ttdeci">#define UART_IER_AUTO_CTS_EN_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09512">Mini51Series.h:9512</a></div></div>
<div class="ttc" id="system___mini51_series_8h_html_a273745e210b52623e70b5cdde9010d1a"><div class="ttname"><a href="system___mini51_series_8h.html#a273745e210b52623e70b5cdde9010d1a">__IRC22M</a></div><div class="ttdeci">#define __IRC22M</div><div class="ttdef"><b>Definition:</b> <a href="system___mini51_series_8h_source.html#l00031">system_Mini51Series.h:31</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a514dcd5496412f6c75381c9c07a22603"><div class="ttname"><a href="_mini51_series_8h.html#a514dcd5496412f6c75381c9c07a22603">UART_FSR_RS485_ADD_DETF_Msk</a></div><div class="ttdeci">#define UART_FSR_RS485_ADD_DETF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09569">Mini51Series.h:9569</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_gace2c59bec6efa5ccd85986f5fa15c7e0"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#gace2c59bec6efa5ccd85986f5fa15c7e0">UART_Read</a></div><div class="ttdeci">uint32_t UART_Read(UART_T *uart, uint8_t *pu8RxBuf, uint32_t u32ReadBytes)</div><div class="ttdoc">The function is used to read Rx data from RX FIFO and the data will be stored in pu8RxBuf.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00195">uart.c:195</a></div></div>
<div class="ttc" id="struct_u_a_r_t___t_html_a27a280db5df6e6fa46d77fe99a4d143b"><div class="ttname"><a href="struct_u_a_r_t___t.html#a27a280db5df6e6fa46d77fe99a4d143b">UART_T::TOR</a></div><div class="ttdeci">__IO uint32_t TOR</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09463">Mini51Series.h:9463</a></div></div>
<div class="ttc" id="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s_html_ga978d8c95e3b536a84f56567f9eb35597"><div class="ttname"><a href="group___m_i_n_i51___u_a_r_t___e_x_p_o_r_t_e_d___f_u_n_c_t_i_o_n_s.html#ga978d8c95e3b536a84f56567f9eb35597">UART_DisableInt</a></div><div class="ttdeci">void UART_DisableInt(UART_T *uart, uint32_t u32InterruptFlag)</div><div class="ttdoc">The function is used to disable UART specified interrupt and disable NVIC UART IRQ.</div><div class="ttdef"><b>Definition:</b> <a href="uart_8c_source.html#l00102">uart.c:102</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a10df7c4c9ac2f83a1241471f7da18add"><div class="ttname"><a href="_mini51_series_8h.html#a10df7c4c9ac2f83a1241471f7da18add">UART_IRCR_TX_SELECT_Msk</a></div><div class="ttdeci">#define UART_IRCR_TX_SELECT_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09659">Mini51Series.h:9659</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a03776650662dad0022ee7cf524e91f2e"><div class="ttname"><a href="_mini51_series_8h.html#a03776650662dad0022ee7cf524e91f2e">UART_ISR_MODEM_INT_Msk</a></div><div class="ttdeci">#define UART_ISR_MODEM_INT_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09632">Mini51Series.h:9632</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_aa1e805b9852c7cc905e6deb907f0e715"><div class="ttname"><a href="_mini51_series_8h.html#aa1e805b9852c7cc905e6deb907f0e715">UART_FSR_PEF_Msk</a></div><div class="ttdeci">#define UART_FSR_PEF_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09572">Mini51Series.h:9572</a></div></div>
<div class="ttc" id="_mini51_series_8h_html_a47abfe1d46dbdeada72be49842f98907"><div class="ttname"><a href="_mini51_series_8h.html#a47abfe1d46dbdeada72be49842f98907">UART_ISR_BUF_ERR_INT_Msk</a></div><div class="ttdeci">#define UART_ISR_BUF_ERR_INT_Msk</div><div class="ttdef"><b>Definition:</b> <a href="_mini51_series_8h_source.html#l09638">Mini51Series.h:9638</a></div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Oct 5 2020 14:31:43 for Mini51 BSP by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
